#include <SoftwareSerial.h>
#include <TinyGPS.h>

TinyGPS gps;
SoftwareSerial serialgps(2,3);
int year;
byte month, day, hour, minute, second, hundredths;
unsigned long chars;
unsigned short sentences, failed_checksum;

int8_t answer;
char aux_string[30];
char phone_number[]="1234567890";


void setup()
{

Serial.begin(9600);
serialgps.begin(9600);
Serial.println("==========================");
Serial.println("GPS");
Serial.println("===========================");

 Serial.println("Connecting to the network...");

    while( (sendATcommand("AT+CREG?", "+CREG: 0,1", 500) || 
            sendATcommand("AT+CREG?", "+CREG: 0,5", 500)) == 0 );
    sendATcommand("AT+CMGF=1", "OK", 1000);    // sets the SMS mode to text
   delay(4000);
 GPRS_connect(); 
   
}
float latitude, longitude;
char flag=0;
void loop()
{
while(serialgps.available()) 
{
int c = serialgps.read(); 
if(gps.encode(c)) 
{

gps.f_get_position(&latitude, &longitude);
//Serial.print("Lat/Long: "); 
//Serial.print(latitude,6); 
//Serial.print(","); 
//Serial.println(longitude,6); 
//Serial.println();
flag=1;
gps.stats(&chars, &sentences, &failed_checksum);
}
}

if(flag==1)
{
 Serial.print("AT+HTTPPARA=\"URL\",\"http://varmatrix.com/Madhu/gprsvalue.php?v1=");
 delay(100);
 
Serial.print(latitude,6); 
Serial.print("&v2="); 
Serial.print(longitude,6); 
      delay(100);
      answer = sendATcommand("\"", "OK", 10000);   
               answer = sendATcommand("AT+HTTPACTION=0", "+HTTPACTION:0,200", 10000);
                   if (answer == 1)
                     {
                         Serial.println("sent"); 
                         delay(2000);
                         flag=0;
                     }
}
}

void power_on(){

    uint8_t answer=0;
    
    // checks if the module is started
    answer = sendATcommand("AT", "OK", 2000);
    if (answer == 0)
    {
     
    
        // waits for an answer from the module
        while(answer == 0){     // Send AT every two seconds and wait for the answer
            answer = sendATcommand("AT", "OK", 2000);    
        }
    }
    
}

int8_t sendATcommand(char* ATcommand, char* expected_answer, unsigned int timeout){

    uint8_t x=0,  answer=0;
    char response[100];
    unsigned long previous;

    memset(response, '\0', 100);    // Initialice the string
    
    delay(100);
    
    while( Serial.available() > 0) Serial.read();    // Clean the input buffer
    
    Serial.println(ATcommand);    // Send the AT command 


    x = 0;
    previous = millis();

    // this loop waits for the answer
    do{
        // if there are data in the UART input buffer, reads it and checks for the asnwer
        if(Serial.available() != 0){    
            response[x] = Serial.read();
            x++;
            // check if the desired answer is in the response of the module
            if (strstr(response, expected_answer) != NULL)    
            {
                answer = 1;
            }
        }
    // Waits for the asnwer with time out
    }while((answer == 0) && ((millis() - previous) < timeout));    

    return answer;
}


void GPRS_connect()
{
  
      sendATcommand("AT+SAPBR=3,1,\"Contype\",\"GPRS\"", "OK", 2000);
    sendATcommand("AT+SAPBR=3,1,\"APN\",\"www\"", "OK", 2000);

    while (sendATcommand("AT+SAPBR=1,1", "OK", 20000) == 0)
    {
        delay(5000);
    }
    delay(1000);
  answer = sendATcommand("AT+HTTPINIT", "OK", 10000);
    if (answer == 1)
    {
        delay(1000);
              answer = sendATcommand("AT+HTTPPARA=\"CID\",1", "OK", 5000);
    }
  
  
}
